Codeforces#364Div2

A题:

题意:给定一些数,然后每两个组成一对,要求每对的和的大小相同,输出这样的组合

分析:直接模拟就行

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <string>
 5 #include <vector>
 6 #include <algorithm>
 7 #include <set>
 8 #include <map>
 9 #include <bitset>
10 #include <cmath>
11 #include <queue>
12 #include <stack>
13 using namespace std;
14 const int maxn=110;
15 int a[maxn];
16 int n;
17 int vis[maxn];
18 int main()
19 {
20     while(cin>>n)
21     {
22         int sum=0;
23         for(int i=1;i<=n;i++)
24         {
25             cin>>a[i];
26             sum+=a[i];
27         }
28         memset (vis,0,sizeof(vis));
29         int ave=n/2;
30         int num=sum/ave;
31         for(int i=1;i<=n;i++){
32             if(!vis[i]){
33                 for(int j=1;j<=n;j++){
34                     if(!vis[j]&&j!=i){
35                         if(a[i]+a[j]==num){
36                             vis[i]=1; vis[j]=1;
37                             cout<<i<<" "<<j<<endl;
38                             break;
39                         }
40                     }
41                 }
42             }else continue;
43         }
44     }
45     return 0;
46 }

B题:

题意:给定n*n的方格,有m个操作,每个操作给定两个坐标系x,y,去掉x行和y列,问每一步操作之后剩下多少

分析:每一步操作就是(n-当前被去掉的行)*(n-当前被去掉的列)

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <string>
 5 #include <vector>
 6 #include <algorithm>
 7 #include <set>
 8 #include <map>
 9 #include <bitset>
10 #include <cmath>
11 #include <queue>
12 #include <stack>
13 using namespace std;
14 const int maxn=100010;
15 long long d[maxn];
16 long long n,m;
17 //int visrow[maxn],viscol[maxn]; //行和列
18 int main()
19 {
20     while(cin>>n>>m)
21     {
22         memset(d,0,sizeof(d));
23         set<long long > row; //行
24         set<long long> col;  //列
25         long long cnt=n*n;
26         for(int i=0;i<m;i++)
27         {
28             long long  x,y;
29             cin>>x>>y;
30             row.insert(x);
31             col.insert(y);
32             int num1=row.size();
33             int num2=col.size();
34             long long sum=(n-num1)*(n-num2);
35             d[i]=sum;
36         }
37         for(int i=0;i<m-1;i++){
38             cout<<d[i]<<" ";
39         }
40         cout<<d[m-1]<<endl;
41     }
42     return 0;
43 }

C题:

题意:求包含所有字母的最短子串长度

分析:对于尚未取到所有字母的位置,不断更新,对于取到了所有字母的位置,用最大位置的减去最小位置,然后去最小值

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <string>
 5 #include <vector>
 6 #include <algorithm>
 7 #include <set>
 8 #include <map>
 9 #include <bitset>
10 #include <cmath>
11 #include <queue>
12 #include <stack>
13 using namespace std;
14 const int maxn=110;
15 int a[maxn];
16 int n;
17 int vis[maxn];
18 int main()
19 {
20     while(cin>>n)
21     {
22         int sum=0;
23         for(int i=1;i<=n;i++)
24         {
25             cin>>a[i];
26             sum+=a[i];
27         }
28         memset (vis,0,sizeof(vis));
29         int ave=n/2;
30         int num=sum/ave;
31         for(int i=1;i<=n;i++){
32             if(!vis[i]){
33                 for(int j=1;j<=n;j++){
34                     if(!vis[j]&&j!=i){
35                         if(a[i]+a[j]==num){
36                             vis[i]=1; vis[j]=1;
37                             cout<<i<<" "<<j<<endl;
38                             break;
39                         }
40                     }
41                 }
42             }else continue;
43         }
44     }
45     return 0;
46 }

时间: 2024-10-07 06:32:42

Codeforces#364Div2的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ